import java.applet.*;
import java.awt.*;
import EvalExpr;

//Ser vivo
class cSerVivo extends Applet
{
	//Instancia del evaluador de expresiones
	EvalExpr eEvalua;

	//Expresion o ADN del ser vivo
	String sExpresion;
	
	//Adaptacion del ser vivo al medio ambiente (entre mas se aproxime a cero mejor)
	float fAproxima;

	//El ambiente
	int m_iSerieNum[] = new int[70];	//El ambiente en numero
	int m_iContSerie;					//Numero de elementos en la serie


	public cSerVivo()
	{
		eEvalua = new EvalExpr();
	}

	public void vAmbiente(String m_sSerieNum)
	{
		int iCont;
		String sAcum="";
		m_iContSerie=0;

		// Ahora deshace la expresion en un arreglo de enteros
		for(iCont=0; iCont<=m_sSerieNum.length()-1; iCont++)
		{
			if (m_sSerieNum.charAt(iCont) != ',' )
				sAcum += m_sSerieNum.charAt(iCont);
			else
			{
				if (sAcum.length()>0)
				{
					m_iSerieNum[m_iContSerie]=Integer.parseInt(sAcum);
					m_iContSerie++;
					sAcum="";
				}
			}
		}
	}
	
	public int iAdaptarse01()  //Chequea su sintaxis
	{
		if (sExpresion.length() > 0)
			return eEvalua.iChequeaSintaxis(sExpresion,1);
		else
			return -1;
	}

	public double dAdaptarse02() //Chequea su adaptacion a la serie (ambiente)
	{
		double dDiferenc; // La diferencia entre la serie y el valor que deduce la expresion
		double dTotDifer=0; //La sumatoria de diferencias
		double dX=0; //Variable X
		int iCont;

		double dResult = eEvalua.dCapturaecuacion(sExpresion, 0, 0);

		for(iCont=0; iCont<m_iContSerie; iCont++)
		{
		   dX++;
		   dDiferenc=m_iSerieNum[iCont]-eEvalua.CicloEvalua(dX, 0);
		   if (eEvalua.m_iERROR==1) return 99999999;
		   if (dDiferenc<0) dDiferenc*=-1;
		   dTotDifer+=dDiferenc;
		}
		return dTotDifer;
	}
}
